package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.SysAdmin;

/**
 * 实体[SysAdminFunc] 数据对象
 */
@TableName(value = "T_SRFSYSADMINFUNC",resultMap = "SysAdminFuncResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class SysAdminFunc extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private SysAdmin sysadmin;
    @TableField(exist = false)//逻辑属性
    private String adminobject;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String funcid;
    private String memo;
    private String param;
    @TableId(value= "sysadminfuncid",type=IdType.UUID)//指定主键生成策略
    private String sysadminfuncid;
    private String sysadminfuncname;
    private String sysadminid;
    @TableField(exist = false)//逻辑属性
    private String sysadminname;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[管理对象]
     *  @param adminobject
     */
    public void setAdminobject(String adminobject){
        if(StringUtils.isEmpty(adminobject))
            adminobject=null;
        this.adminobject = adminobject;
        this.set("adminobjectdirtyflag",true);
    }
    /**
     *  获取属性值[管理对象]
     */
    public String getAdminobject(){
        return this.adminobject;
    }
    /**
     *  重置属性值[管理对象]
     */
    public void resetAdminobject(){
        this.set("adminobjectdirtyflag",false);
        this.adminobject = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[功能编号]
     *  @param funcid
     */
    public void setFuncid(String funcid){
        if(StringUtils.isEmpty(funcid))
            funcid=null;
        this.funcid = funcid;
        this.set("funciddirtyflag",true);
    }
    /**
     *  获取属性值[功能编号]
     */
    public String getFuncid(){
        return this.funcid;
    }
    /**
     *  重置属性值[功能编号]
     */
    public void resetFuncid(){
        this.set("funciddirtyflag",false);
        this.funcid = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[参数]
     *  @param param
     */
    public void setParam(String param){
        if(StringUtils.isEmpty(param))
            param=null;
        this.param = param;
        this.set("paramdirtyflag",true);
    }
    /**
     *  获取属性值[参数]
     */
    public String getParam(){
        return this.param;
    }
    /**
     *  重置属性值[参数]
     */
    public void resetParam(){
        this.set("paramdirtyflag",false);
        this.param = null;
    }
    /**
     *  设置属性值[系统管理功能标识]
     *  @param sysadminfuncid
     */
    public void setSysadminfuncid(String sysadminfuncid){
        if(StringUtils.isEmpty(sysadminfuncid))
            sysadminfuncid=null;
        this.sysadminfuncid = sysadminfuncid;
        this.set("sysadminfunciddirtyflag",true);
    }
    /**
     *  获取属性值[系统管理功能标识]
     */
    public String getSysadminfuncid(){
        return this.sysadminfuncid;
    }
    /**
     *  重置属性值[系统管理功能标识]
     */
    public void resetSysadminfuncid(){
        this.set("sysadminfunciddirtyflag",false);
        this.sysadminfuncid = null;
    }
    /**
     *  设置属性值[系统管理功能名称]
     *  @param sysadminfuncname
     */
    public void setSysadminfuncname(String sysadminfuncname){
        if(StringUtils.isEmpty(sysadminfuncname))
            sysadminfuncname=null;
        this.sysadminfuncname = sysadminfuncname;
        this.set("sysadminfuncnamedirtyflag",true);
    }
    /**
     *  获取属性值[系统管理功能名称]
     */
    public String getSysadminfuncname(){
        return this.sysadminfuncname;
    }
    /**
     *  重置属性值[系统管理功能名称]
     */
    public void resetSysadminfuncname(){
        this.set("sysadminfuncnamedirtyflag",false);
        this.sysadminfuncname = null;
    }
    /**
     *  设置属性值[系统管理功能_管理模块]
     *  @param sysadminid
     */
    public void setSysadminid(String sysadminid){
        if(StringUtils.isEmpty(sysadminid))
            sysadminid=null;
        this.sysadminid = sysadminid;
        this.set("sysadminiddirtyflag",true);
    }
    /**
     *  获取属性值[系统管理功能_管理模块]
     */
    public String getSysadminid(){
        return this.sysadminid;
    }
    /**
     *  重置属性值[系统管理功能_管理模块]
     */
    public void resetSysadminid(){
        this.set("sysadminiddirtyflag",false);
        this.sysadminid = null;
    }
    /**
     *  设置属性值[管理模块]
     *  @param sysadminname
     */
    public void setSysadminname(String sysadminname){
        if(StringUtils.isEmpty(sysadminname))
            sysadminname=null;
        this.sysadminname = sysadminname;
        this.set("sysadminnamedirtyflag",true);
    }
    /**
     *  获取属性值[管理模块]
     */
    public String getSysadminname(){
        return this.sysadminname;
    }
    /**
     *  重置属性值[管理模块]
     */
    public void resetSysadminname(){
        this.set("sysadminnamedirtyflag",false);
        this.sysadminname = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
     /**
     *  获取主实体关联数据[SysAdmin]
     */
    public SysAdmin getSysadmin() {
        return sysadmin;
    }
    /**
     *  设置主实体关联数据[SysAdmin]
     */
    public void setSysadmin(SysAdmin sysadmin) {
        this.sysadmin = sysadmin;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetAdminobject();
        resetCreatedate();
        resetCreateman();
        resetFuncid();
        resetMemo();
        resetParam();
        resetSysadminfuncid();
        resetSysadminfuncname();
        resetSysadminid();
        resetSysadminname();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public SysAdminFunc copyTo(SysAdminFunc targetEntity)
	{
		BeanCopier copier=BeanCopier.create(SysAdminFunc.class, SysAdminFunc.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetSysadminfuncid();
		return targetEntity;
	}
}